package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.libgdx.LibGDX _lgdx = null;
public anywheresoftware.b4a.libgdx.graphics.lgGL _gl = null;
public anywheresoftware.b4a.libgdx.graphics.lgTextureAtlas _atlas = null;
public anywheresoftware.b4a.libgdx.graphics.lgBitmapFont _font = null;
public anywheresoftware.b4a.libgdx.scene2d.lgStage _stage = null;
public anywheresoftware.b4a.libgdx.scene2d.lgScrollPane _scrollpane = null;
public anywheresoftware.b4a.libgdx.scene2d.lgScrollPane.lgScrollPaneStyle _stylscrollpane = null;
public com.badlogic.gdx.scenes.scene2d.Group _grpscroll = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 33;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 35;BA.debugLine="lGdx.Initialize(\"LG\")";
mostCurrent._lgdx.Initialize(mostCurrent.activityBA,"LG");
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 43;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 45;BA.debugLine="If lGdx.IsInitialized Then lGdx.Pause";
if (mostCurrent._lgdx.IsInitialized()) { 
mostCurrent._lgdx.Pause();};
 //BA.debugLineNum = 46;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 40;BA.debugLine="If lGdx.IsInitialized Then lGdx.Resume";
if (mostCurrent._lgdx.IsInitialized()) { 
mostCurrent._lgdx.Resume();};
 //BA.debugLineNum = 41;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 19;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 20;BA.debugLine="Dim lGdx As LibGDX";
mostCurrent._lgdx = new anywheresoftware.b4a.libgdx.LibGDX();
 //BA.debugLineNum = 21;BA.debugLine="Dim GL As lgGL";
mostCurrent._gl = new anywheresoftware.b4a.libgdx.graphics.lgGL();
 //BA.debugLineNum = 22;BA.debugLine="Dim Atlas As lgTextureAtlas";
mostCurrent._atlas = new anywheresoftware.b4a.libgdx.graphics.lgTextureAtlas();
 //BA.debugLineNum = 23;BA.debugLine="Dim Font As lgBitmapFont";
mostCurrent._font = new anywheresoftware.b4a.libgdx.graphics.lgBitmapFont();
 //BA.debugLineNum = 24;BA.debugLine="Dim Stage As lgScn2DStage";
mostCurrent._stage = new anywheresoftware.b4a.libgdx.scene2d.lgStage();
 //BA.debugLineNum = 26;BA.debugLine="Dim ScrollPane As lgScn2DScrollPane";
mostCurrent._scrollpane = new anywheresoftware.b4a.libgdx.scene2d.lgScrollPane();
 //BA.debugLineNum = 27;BA.debugLine="Dim stylScrollPane As lgScn2DScrollPaneStyle";
mostCurrent._stylscrollpane = new anywheresoftware.b4a.libgdx.scene2d.lgScrollPane.lgScrollPaneStyle();
 //BA.debugLineNum = 29;BA.debugLine="Dim grpScroll As lgScn2DGroup";
mostCurrent._grpscroll = new com.badlogic.gdx.scenes.scene2d.Group();
 //BA.debugLineNum = 31;BA.debugLine="End Sub";
return "";
}
public static String  _lg_create() throws Exception{
anywheresoftware.b4a.libgdx.graphics.lgTextureAtlasRegion _region = null;
anywheresoftware.b4a.libgdx.scene2d.lgNinePatchDrawable _nppanebkgd = null;
anywheresoftware.b4a.libgdx.scene2d.lgNinePatchDrawable _nppanescroll = null;
anywheresoftware.b4a.libgdx.scene2d.lgNinePatchDrawable _nppaneknob = null;
anywheresoftware.b4a.libgdx.scene2d.lgTable _pogrouptable = null;
com.badlogic.gdx.scenes.scene2d.actions.Actions _actions = null;
com.badlogic.gdx.math.Interpolation _interpolation = null;
anywheresoftware.b4a.libgdx.scene2d.lgLabel.lgLabelStyle _lblstyle = null;
int _piy = 0;
int _piitem = 0;
anywheresoftware.b4a.libgdx.graphics.lgPixmap _mypix = null;
String _psfile = "";
anywheresoftware.b4a.libgdx.graphics.lgTexture _potex = null;
anywheresoftware.b4a.libgdx.scene2d.lgImage _poicon = null;
com.badlogic.gdx.scenes.scene2d.ui.Cell _pocell = null;
anywheresoftware.b4a.libgdx.scene2d.lgLabel _polbl = null;
com.badlogic.gdx.scenes.scene2d.ui.Cell _porightside = null;
 //BA.debugLineNum = 48;BA.debugLine="Sub LG_Create";
 //BA.debugLineNum = 50;BA.debugLine="Stage.Initialize(\"\")";
mostCurrent._stage.Initialize(processBA,"");
 //BA.debugLineNum = 53;BA.debugLine="Atlas.InitializeWithFile(\"atlas/uiskin.pack\")";
mostCurrent._atlas.InitializeWithFile("atlas/uiskin.pack");
 //BA.debugLineNum = 56;BA.debugLine="Dim Region As lgTextureAtlasRegion = Atlas.FindRegion(\"arial22\")";
_region = mostCurrent._atlas.FindRegion("arial22");
 //BA.debugLineNum = 57;BA.debugLine="Font.Initialize4(lGdx.Files.internal(\"font/arial22.fnt\"), Region)";
mostCurrent._font.Initialize4(mostCurrent._lgdx.Files().internal("font/arial22.fnt"),(anywheresoftware.b4a.libgdx.graphics.lgTextureRegion)(_region));
 //BA.debugLineNum = 58;BA.debugLine="Font.SetTextureFilter(Font.FILTER_Linear, Font.FILTER_Linear)";
mostCurrent._font.SetTextureFilter(mostCurrent._font.FILTER_Linear,mostCurrent._font.FILTER_Linear);
 //BA.debugLineNum = 59;BA.debugLine="Font.Scale(Density * 1.1)";
mostCurrent._font.Scale((float) (anywheresoftware.b4a.keywords.Common.Density*1.1));
 //BA.debugLineNum = 63;BA.debugLine="Dim npPaneBkgd As lgScn2DNinePatchDrawable";
_nppanebkgd = new anywheresoftware.b4a.libgdx.scene2d.lgNinePatchDrawable();
 //BA.debugLineNum = 64;BA.debugLine="npPaneBkgd.Initialize2(Atlas.Create9Patch(\"default-rect\"))";
_nppanebkgd.Initialize2(mostCurrent._atlas.Create9Patch("default-rect"));
 //BA.debugLineNum = 65;BA.debugLine="npPaneBkgd.LeftWidth = 4dip";
_nppanebkgd.setLeftWidth((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (4))));
 //BA.debugLineNum = 66;BA.debugLine="npPaneBkgd.RightWidth = 4dip";
_nppanebkgd.setRightWidth((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (4))));
 //BA.debugLineNum = 69;BA.debugLine="Dim npPaneScroll As lgScn2DNinePatchDrawable";
_nppanescroll = new anywheresoftware.b4a.libgdx.scene2d.lgNinePatchDrawable();
 //BA.debugLineNum = 70;BA.debugLine="npPaneScroll.Initialize2(Atlas.Create9Patch(\"default-scroll\"))";
_nppanescroll.Initialize2(mostCurrent._atlas.Create9Patch("default-scroll"));
 //BA.debugLineNum = 71;BA.debugLine="Dim npPaneKnob As lgScn2DNinePatchDrawable";
_nppaneknob = new anywheresoftware.b4a.libgdx.scene2d.lgNinePatchDrawable();
 //BA.debugLineNum = 72;BA.debugLine="npPaneKnob.Initialize2(Atlas.Create9Patch(\"default-round-large\"))";
_nppaneknob.Initialize2(mostCurrent._atlas.Create9Patch("default-round-large"));
 //BA.debugLineNum = 77;BA.debugLine="grpScroll.Initialize(\"ScrollGroup\")";
mostCurrent._grpscroll.Initialize(processBA,"ScrollGroup");
 //BA.debugLineNum = 78;BA.debugLine="grpScroll.Height = 60dip";
mostCurrent._grpscroll.setHeight((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60))));
 //BA.debugLineNum = 79;BA.debugLine="grpScroll.Width = lGdx.Graphics.Width - npPaneScroll.MinWidth - 20dip";
mostCurrent._grpscroll.setWidth((float) (mostCurrent._lgdx.Graphics().getWidth()-_nppanescroll.getMinWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (20))));
 //BA.debugLineNum = 81;BA.debugLine="Dim poGroupTable As lgScn2DTable";
_pogrouptable = new anywheresoftware.b4a.libgdx.scene2d.lgTable();
 //BA.debugLineNum = 82;BA.debugLine="poGroupTable.Initialize(\"\")";
_pogrouptable.Initialize(processBA,"");
 //BA.debugLineNum = 83;BA.debugLine="grpScroll.addActor(poGroupTable)";
mostCurrent._grpscroll.addActor((com.badlogic.gdx.scenes.scene2d.Actor)(_pogrouptable));
 //BA.debugLineNum = 84;BA.debugLine="poGroupTable.FillParent = True";
_pogrouptable.setFillParent(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 85;BA.debugLine="poGroupTable.align = poGroupTable.ALIGN_Left + poGroupTable.ALIGN_Top";
_pogrouptable.setAlign((int) (_pogrouptable.ALIGN_Left+_pogrouptable.ALIGN_Top));
 //BA.debugLineNum = 88;BA.debugLine="stylScrollPane.Initialize(npPaneBkgd, npPaneScroll, npPaneKnob, npPaneScroll, npPaneKnob)";
mostCurrent._stylscrollpane.Initialize((com.badlogic.gdx.scenes.scene2d.utils.Drawable)(_nppanebkgd),(com.badlogic.gdx.scenes.scene2d.utils.Drawable)(_nppanescroll),(com.badlogic.gdx.scenes.scene2d.utils.Drawable)(_nppaneknob),(com.badlogic.gdx.scenes.scene2d.utils.Drawable)(_nppanescroll),(com.badlogic.gdx.scenes.scene2d.utils.Drawable)(_nppaneknob));
 //BA.debugLineNum = 89;BA.debugLine="stylScrollPane.SetScrollbarWidth(30dip)";
mostCurrent._stylscrollpane.SetScrollbarWidth((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30))));
 //BA.debugLineNum = 92;BA.debugLine="ScrollPane.Initialize(grpScroll, stylScrollPane, \"SP\")";
mostCurrent._scrollpane.Initialize(processBA,(com.badlogic.gdx.scenes.scene2d.Actor)(mostCurrent._grpscroll),mostCurrent._stylscrollpane,"SP");
 //BA.debugLineNum = 93;BA.debugLine="ScrollPane.X = lGdx.Graphics.Width";
mostCurrent._scrollpane.setX((float) (mostCurrent._lgdx.Graphics().getWidth()));
 //BA.debugLineNum = 94;BA.debugLine="ScrollPane.Y = 5dip";
mostCurrent._scrollpane.setY((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (5))));
 //BA.debugLineNum = 95;BA.debugLine="ScrollPane.Width = lGdx.Graphics.Width - 10dip";
mostCurrent._scrollpane.setWidth((float) (mostCurrent._lgdx.Graphics().getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10))));
 //BA.debugLineNum = 96;BA.debugLine="ScrollPane.Height = lGdx.Graphics.Height - 10dip";
mostCurrent._scrollpane.setHeight((float) (mostCurrent._lgdx.Graphics().getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10))));
 //BA.debugLineNum = 97;BA.debugLine="Stage.AddActor(ScrollPane)";
mostCurrent._stage.AddActor((com.badlogic.gdx.scenes.scene2d.Actor)(mostCurrent._scrollpane));
 //BA.debugLineNum = 100;BA.debugLine="Dim Actions As lgScn2DActions";
_actions = new com.badlogic.gdx.scenes.scene2d.actions.Actions();
 //BA.debugLineNum = 101;BA.debugLine="Dim Interpolation As lgMathInterpolation";
_interpolation = new com.badlogic.gdx.math.Interpolation();
 //BA.debugLineNum = 102;BA.debugLine="ScrollPane.AddAction(Actions.MoveTo3(5dip, ScrollPane.Y, 1, Interpolation.bounceOut))";
mostCurrent._scrollpane.addAction((com.badlogic.gdx.scenes.scene2d.Action)(_actions.MoveTo3((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (5))),mostCurrent._scrollpane.getY(),(float) (1),_interpolation.bounceOut)));
 //BA.debugLineNum = 104;BA.debugLine="Dim lblStyle As lgScn2DLabelStyle";
_lblstyle = new anywheresoftware.b4a.libgdx.scene2d.lgLabel.lgLabelStyle();
 //BA.debugLineNum = 105;BA.debugLine="lblStyle.Initialize(Font, Font.Color.WHITE)";
_lblstyle.Initialize(mostCurrent._font,mostCurrent._font.getColor().WHITE);
 //BA.debugLineNum = 108;BA.debugLine="Dim piY As Int = 0";
_piy = (int) (0);
 //BA.debugLineNum = 109;BA.debugLine="Dim piItem As Int";
_piitem = 0;
 //BA.debugLineNum = 110;BA.debugLine="For piItem = 1 To 10";
{
final int step59 = 1;
final int limit59 = (int) (10);
for (_piitem = (int) (1); (step59 > 0 && _piitem <= limit59) || (step59 < 0 && _piitem >= limit59); _piitem = ((int)(0 + _piitem + step59))) {
 //BA.debugLineNum = 111;BA.debugLine="If piItem <> 1 Then";
if (_piitem!=1) { 
 //BA.debugLineNum = 112;BA.debugLine="poGroupTable.NewRow()";
_pogrouptable.NewRow();
 };
 //BA.debugLineNum = 115;BA.debugLine="Dim myPix As lgPixmap";
_mypix = new anywheresoftware.b4a.libgdx.graphics.lgPixmap();
 //BA.debugLineNum = 116;BA.debugLine="Dim psFile As String = \"image_\" & NumberFormat(piItem, 2, 0) & \".png\"";
_psfile = "image_"+anywheresoftware.b4a.keywords.Common.NumberFormat(_piitem,(int) (2),(int) (0))+".png";
 //BA.debugLineNum = 117;BA.debugLine="myPix.InitializeWithFile(lGdx.Files.Internal(psFile))";
_mypix.InitializeWithFile(mostCurrent._lgdx.Files().internal(_psfile));
 //BA.debugLineNum = 118;BA.debugLine="Dim poTex As lgTexture";
_potex = new anywheresoftware.b4a.libgdx.graphics.lgTexture();
 //BA.debugLineNum = 119;BA.debugLine="poTex.InitializeWithPixmap(myPix)";
_potex.InitializeWithPixmap(_mypix);
 //BA.debugLineNum = 120;BA.debugLine="Dim poIcon As lgScn2DImage";
_poicon = new anywheresoftware.b4a.libgdx.scene2d.lgImage();
 //BA.debugLineNum = 121;BA.debugLine="poIcon.Initialize4(poTex, \"\")";
_poicon.Initialize4(processBA,_potex,"");
 //BA.debugLineNum = 122;BA.debugLine="myPix.dispose";
_mypix.dispose();
 //BA.debugLineNum = 124;BA.debugLine="Dim poCell As lgScn2DTableCell";
_pocell = new com.badlogic.gdx.scenes.scene2d.ui.Cell();
 //BA.debugLineNum = 125;BA.debugLine="poCell = poGroupTable.AddActor(poIcon)";
_pocell = _pogrouptable.AddActor((com.badlogic.gdx.scenes.scene2d.Actor)(_poicon));
 //BA.debugLineNum = 126;BA.debugLine="poCell.Height = 60dip";
_pocell.setHeight((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60))));
 //BA.debugLineNum = 127;BA.debugLine="poCell.Width = 60dip";
_pocell.setWidth((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60))));
 //BA.debugLineNum = 128;BA.debugLine="poIcon.Width = 60dip";
_poicon.setWidth((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60))));
 //BA.debugLineNum = 129;BA.debugLine="poIcon.Height = 60dip";
_poicon.setHeight((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60))));
 //BA.debugLineNum = 130;BA.debugLine="poCell.AlignLeft";
_pocell.AlignLeft();
 //BA.debugLineNum = 131;BA.debugLine="poCell.Pad(2dip)";
_pocell.Pad((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (2))));
 //BA.debugLineNum = 133;BA.debugLine="Dim poLbl As lgScn2DLabel";
_polbl = new anywheresoftware.b4a.libgdx.scene2d.lgLabel();
 //BA.debugLineNum = 134;BA.debugLine="poLbl.initialize(\"  Item \" & piItem, lblStyle, \"\")";
_polbl.Initialize(processBA,(java.lang.CharSequence)("  Item "+BA.NumberToString(_piitem)),_lblstyle,"");
 //BA.debugLineNum = 135;BA.debugLine="poLbl.SetFontScale2(3.5)";
_polbl.SetFontScale2((float) (3.5));
 //BA.debugLineNum = 136;BA.debugLine="poLbl.AutoPack = True";
_polbl.setAutoPack(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 138;BA.debugLine="Dim poRightSide As lgScn2DTableCell";
_porightside = new com.badlogic.gdx.scenes.scene2d.ui.Cell();
 //BA.debugLineNum = 139;BA.debugLine="poRightSide = poGroupTable.AddCell";
_porightside = _pogrouptable.AddCell();
 //BA.debugLineNum = 140;BA.debugLine="poRightSide.Height = 60dip";
_porightside.setHeight((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60))));
 //BA.debugLineNum = 141;BA.debugLine="poRightSide.Width = grpScroll.Width - 110dip";
_porightside.setWidth((float) (mostCurrent._grpscroll.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (110))));
 //BA.debugLineNum = 142;BA.debugLine="poRightSide.Pad(2dip)";
_porightside.Pad((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (2))));
 //BA.debugLineNum = 143;BA.debugLine="poRightSide.Actor = poLbl";
_porightside.setActor((Object)(_polbl));
 //BA.debugLineNum = 145;BA.debugLine="piY = piY + 64dip ' 60 high plus cell padding";
_piy = (int) (_piy+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (64)));
 }
};
 //BA.debugLineNum = 149;BA.debugLine="grpScroll.Height = piY + 20dip";
mostCurrent._grpscroll.setHeight((float) (_piy+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (20))));
 //BA.debugLineNum = 151;BA.debugLine="End Sub";
return "";
}
public static String  _lg_dispose() throws Exception{
 //BA.debugLineNum = 176;BA.debugLine="Sub LG_Dispose";
 //BA.debugLineNum = 178;BA.debugLine="Stage.dispose";
mostCurrent._stage.dispose();
 //BA.debugLineNum = 179;BA.debugLine="Font.dispose";
mostCurrent._font.dispose();
 //BA.debugLineNum = 180;BA.debugLine="Atlas.dispose";
mostCurrent._atlas.dispose();
 //BA.debugLineNum = 181;BA.debugLine="End Sub";
return "";
}
public static String  _lg_pause() throws Exception{
 //BA.debugLineNum = 170;BA.debugLine="Sub LG_Pause";
 //BA.debugLineNum = 171;BA.debugLine="End Sub";
return "";
}
public static String  _lg_render() throws Exception{
 //BA.debugLineNum = 158;BA.debugLine="Sub LG_Render";
 //BA.debugLineNum = 160;BA.debugLine="GL.glClearColor(0.45, 0.45, 0.7, 1)";
mostCurrent._gl.glClearColor((float) (0.45),(float) (0.45),(float) (0.7),(float) (1));
 //BA.debugLineNum = 161;BA.debugLine="GL.glClear(GL.GL10_COLOR_BUFFER_BIT)";
mostCurrent._gl.glClear(mostCurrent._gl.GL10_COLOR_BUFFER_BIT);
 //BA.debugLineNum = 164;BA.debugLine="Stage.Act";
mostCurrent._stage.Act();
 //BA.debugLineNum = 167;BA.debugLine="Stage.Draw";
mostCurrent._stage.Draw();
 //BA.debugLineNum = 168;BA.debugLine="End Sub";
return "";
}
public static String  _lg_resize(int _width,int _height) throws Exception{
 //BA.debugLineNum = 153;BA.debugLine="Sub LG_Resize(Width As Int, Height As Int)";
 //BA.debugLineNum = 155;BA.debugLine="Stage.SetViewport(Width, Height, True)";
mostCurrent._stage.SetViewport((float) (_width),(float) (_height),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 156;BA.debugLine="End Sub";
return "";
}
public static String  _lg_resume() throws Exception{
 //BA.debugLineNum = 173;BA.debugLine="Sub LG_Resume";
 //BA.debugLineNum = 174;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 17;BA.debugLine="End Sub";
return "";
}
}
